<template>
  <div class="row">
    <div class="col-12">
      <button class="btn btn-secondary float-right" type="button" @click="click">Retour</button>
    </div>
    <div class="col-12">
      <h3 v-if="project.path">Télécharger Le Document</h3>
      <p>{{fileName}}</p>
      <button v-if="project.path" class="btn btn-primary" @click="dowload">Télécharger Document</button>
      <button v-if="project.path" class="btn btn-primary" @click="switchs">Modifier Document</button>
      <br>
      <hr>
      <br>
      <form enctype="multipart/form-data" v-if="visible">
        <h3>Modifier Le Document</h3>
        <div class="row">
          <div class="col-4 offset-4">
            <div class="form-group">
              <input class="form-control" type="file" name="file" @change="filesChange($event.target.name, $event.target.files);">
            </div>
          </div>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import { upload } from '@/api/upload.service.js';
import { editProject } from '@/api/projects.service.js';
export default {
  data() {
    return {
      visible: false
    }
  },
  computed: {
    project() {
      return this.$store.getters.getCurrentProject;
    },
    fileName() {
      if (this.project && this.$store.getters.getCurrentProject.path) {
        let path = this.$store.getters.getCurrentProject.path;
        let arr = path.split('/')
        return arr[arr.length - 1];
      } else {
        this.visible = true;
      }
      return "";
    }
  },
  methods: {
    save(formData) {
      upload(formData)
        .then(x => {
          let project = this.$store.getters.getCurrentProject;
          project.path = x.data.data.path;
          editProject(project._id, project);
        })
        .catch(err => {
          console.log(err)
          alert("Une erreur s'est produite");
        });
    },
    filesChange(fieldName, fileList) {

      const formData = new FormData();
      if (!fileList.length) return;
      Array
        .from(Array(fileList.length).keys())
        .map(x => {
          formData.append(fieldName, fileList[x], fileList[x].name);
        });

      // save it
      this.save(formData);
    },
    click() {
      this.$router.go(-1)
    },
    dowload() {
      let project = this.$store.getters.getCurrentProject;
      window.open(project.path);
    },
    switchs() {
      this.visible = !this.visible;
    }

  },
  created() {

    this.$store.dispatch('setProjectById', this.$route.params.id);
  }

}
</script>

<style>

</style>
